unit CoreExports;

interface

uses
  Windows;

procedure InitDLL;

function GetNumCards: LongWord; cdecl;
function QueryCardID(CardNum: LongWord; pID: PLongWord): LongWord; cdecl;
function QueryCardBase(CardNum: LongWord; pBase: PLongWord): LongWord; cdecl;
function WaitForIRQ(CardNum: LongWord): LongWord; cdecl;
function WaitForIRQData(CardNum: LongWord; DataBytes: LongInt; pData: Pointer): LongWord; cdecl;
function RelInPortStringW(CardNum, Offset, Words: LongWord; pData: PWord): LongWord; cdecl;
function InPortStringW(Address, Words: LongWord; pData: PWord): LongWord; cdecl;

function   RelInPortB (CardNum, Offset: LongWord                 ): Word;     cdecl;
function   RelInPort  (CardNum, Offset: LongWord                 ): Word;     cdecl;
function   RelInPortL (CardNum, Offset: LongWord                 ): LongWord; cdecl;
function   RelOutPortB(CardNum, Offset: LongWord; Value: Byte    ): Word;     cdecl;
function   RelOutPort (CardNum, Offset: LongWord; Value: Word    ): Word;     cdecl;
function   RelOutPortL(CardNum, Offset: LongWord; Value: LongWord): Word;     cdecl;

function      InPortB (Addr: LongWord                 ): Word;     cdecl;
function      InPort  (Addr: LongWord                 ): Word;     cdecl;
function      InPortL (Addr: LongWord                 ): LongWord; cdecl;
function      OutPortB(Addr: LongWord; Value: Byte    ): Word;     cdecl;
function      OutPort (Addr: LongWord; Value: Word    ): Word;     cdecl;
function      OutPortL(Addr: LongWord; Value: LongWord): Word;     cdecl;

function VBGetNumCards: LongWord; stdcall;
function VBQueryCardID(CardNum: LongWord; pID: PLongWord): LongWord; stdcall;
function VBQueryCardBase(CardNum: LongWord; pBase: PLongWord): LongWord; stdcall;
function VBWaitForIRQ(CardNum: LongWord): LongWord; stdcall;
function VBWaitForIRQData(CardNum: LongWord; DataBytes: LongInt; pData: Pointer): LongWord; stdcall;
function VBRelInPortStringW(CardNum, Offset, Words: LongWord; pData: PWord): LongWord; stdcall;
function VBInPortStringW(Address, Words: LongWord; pData: PWord): LongWord; stdcall;

function VBRelInPortB (CardNum, Offset: LongWord                 ): Word;     stdcall;
function VBRelInPort  (CardNum, Offset: LongWord                 ): Word;     stdcall;
function VBRelInPortL (CardNum, Offset: LongWord                 ): LongWord; stdcall;
function VBRelOutPortB(CardNum, Offset: LongWord; Value: Byte    ): Word;     stdcall;
function VBRelOutPort (CardNum, Offset: LongWord; Value: Word    ): Word;     stdcall;
function VBRelOutPortL(CardNum, Offset: LongWord; Value: LongWord): Word;     stdcall;

function    VBInPortB (Addr: LongWord                 ): Word;     stdcall;
function    VBInPort  (Addr: LongWord                 ): Word;     stdcall;
function    VBInPortL (Addr: LongWord                 ): LongWord; stdcall;
function    VBOutPortB(Addr: LongWord; Value: Byte    ): Word;     stdcall;
function    VBOutPort (Addr: LongWord; Value: Word    ): Word;     stdcall;
function    VBOutPortL(Addr: LongWord; Value: LongWord): Word;     stdcall;





implementation

uses
  SetupDi, WDMIO;

const
  METHOD_BUFFERED = 0;
  FILE_ANY_ACCESS = 0;
  FILE_READ_ACCESS = 1;
  FILE_WRITE_ACCESS = 2;
  FILE_DEVICE_KRNLDRVR = $80FF;
  //AIO16NT_TYPE = $9C40;

  IOCTL_QUERY_ID       = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($800 shl 2) or (METHOD_BUFFERED) or (FILE_READ_ACCESS  shl 14));
  IOCTL_QUERY_BASE     = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($801 shl 2) or (METHOD_BUFFERED) or (FILE_READ_ACCESS  shl 14));

  IOCTL_IRQ_WAIT_BEGIN = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($810 shl 2) or (METHOD_BUFFERED) or (FILE_READ_ACCESS  shl 14));
  IOCTL_IRQ_WAIT_ABORT = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($812 shl 2) or (METHOD_BUFFERED) or (FILE_ANY_ACCESS   shl 14));
  IOCTL_FORGET_IRP     = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($880 shl 2) or (METHOD_BUFFERED) or (FILE_WRITE_ACCESS shl 14));

  //IOCTL_PORT_IN        = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($820 shl 2) or (METHOD_BUFFERED) or (FILE_READ_ACCESS  shl 14));
  //IOCTL_PORT_OUT       = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($822 shl 2) or (METHOD_BUFFERED) or (FILE_WRITE_ACCESS shl 14));
  IOCTL_PORT_IN_STRING = LongWord((FILE_DEVICE_KRNLDRVR shl 16) or ($814 shl 2) or (METHOD_BUFFERED) or (FILE_READ_ACCESS  shl 14));

  cnNone = $FFFFFFFF;

  AIO167ClassGUID: TGUID = (D1: $C9F55249; D2: $E3F1; D3: $3C84; D4: ($14, $45, $94, $B6, $F8, $08, $61, $34) );

type
  TStringArray = array of AnsiString;

  TPortOp = packed record
    Addr: Word;
    Flags: Byte;
    Size: Byte;
    Data: LongWord;
  end;

  TDeviceData = record
    hDevice: THandle;
    DevPath: AnsiString;
  end;

var
  Device: array of TDeviceData;
  hCentralDevice: THandle;

procedure LoadCardList; forward;





function ValidateCardNum(var CardNum: LongWord): LongWord;
begin
  if CardNum >= LongWord(Length(Device)) then begin
    Result := ERROR_INVALID_INDEX;
    Exit;
  end;
  Result := ERROR_SUCCESS;
end;

function TestValidateCardNumAndSet(var CardNum: LongWord): Boolean;
var
  ErrCode: LongWord;

begin
  ErrCode := ValidateCardNum(CardNum);
  SetLastError(ErrCode);
  Result := ErrCode = ERROR_SUCCESS;
end;

function DoIOCTL(hFile: THandle; IOCTLCode: LongWord; pOutDataBack: PLongWord; InDataBytes: LongWord = 0; pInData: Pointer = nil; OutDataBytes: LongWord = 0; pOutData: Pointer = nil; pOvl: POverlapped = nil): LongWord;
begin
  if DeviceIoControl(hFile, IOCTLCode, pInData, InDataBytes, pOutData, OutDataBytes, pOutDataBack^, pOvl) then begin
    Result := ERROR_SUCCESS;
  end
  else begin
    Result := GetLastError;
    if Result = ERROR_SUCCESS then Result := ERROR_GEN_FAILURE;
  end;
end;

function GetOverlapped: POverlapped;
begin
  New(Result);
  Result.Internal := 0;
  Result.InternalHigh := 0;
  Result.Offset := 0;
  Result.OffsetHigh := 0;
  Result.hEvent := CreateEvent(nil, True, False, '');
end;

procedure ReleaseOverlapped(pOvl: POverlapped);
begin
  CloseHandle(pOvl.hEvent);
  Dispose(pOvl);
end;



function GetNumCards: LongWord; cdecl;
begin
  Result := Length(Device);
  SetLastError(ERROR_SUCCESS);
end;

function QueryCardID(CardNum: LongWord; pID: PLongWord): LongWord; cdecl;
var
  BytesBack: LongWord;

begin
  Result := ValidateCardNum(CardNum);
  if Result <> ERROR_SUCCESS then Exit;

  Result := DoIOCTL(
    Device[CardNum].hDevice,
    IOCTL_QUERY_ID,
    @BytesBack,
    0, nil,
    4, pID
  );
  //if Result <> ERROR_SUCCESS then Exit;
  //if BytesBack < 4 then Result := ERROR_
end;

function QueryCardBase(CardNum: LongWord; pBase: PLongWord): LongWord; cdecl;
var
  BytesBack: LongWord;

begin
  Result := ValidateCardNum(CardNum);
  if Result <> ERROR_SUCCESS then Exit;

  Result := DoIOCTL(
    Device[CardNum].hDevice,
    IOCTL_QUERY_BASE,
    @BytesBack,
    0, nil,
    4, pBase
  );
  //if Result <> ERROR_SUCCESS then Exit;
  //if BytesBack < 4 then Result := ERROR_
end;

function WaitForIRQ(CardNum: LongWord): LongWord; cdecl;
var
  pOvl: POverlapped;
  cbRet: LongWord;

begin
  pOvl := GetOverlapped;
  try
    Result := DoIOCTL(Device[CardNum].hDevice, IOCTL_IRQ_WAIT_BEGIN, @cbRet, 0, nil, 0, nil, pOvl);
    case Result of
      ERROR_SUCCESS: ; //Immediate completion, likely a historical IRQ.
      ERROR_IO_PENDING: begin //Time to wait.
        GetOverlappedResult(Device[CardNum].hDevice, pOvl^, cbRet, true);
        Result := GetLastError;
        if Result = ERROR_NO_MORE_FILES then Result := ERROR_SUCCESS;
        //Else ERROR_OPERATION_ABORTED or other error, either way just pass it along.
      end;
      //Else some error, pass it along.
    end;
  finally
    ReleaseOverlapped(pOvl);
  end;
end;

function WaitForIRQData(CardNum: LongWord; DataBytes: LongInt; pData: Pointer): LongWord; cdecl;
var
  pOvl: POverlapped;
  BytesBack: LongWord;

begin
  pOvl := GetOverlapped;
  try
    Result := DoIOCTL(Device[CardNum].hDevice, IOCTL_IRQ_WAIT_BEGIN, @BytesBack, 0, nil, DataBytes, pData, pOvl);
    case Result of
      ERROR_SUCCESS: ; //Immediate completion, likely a historical IRQ.
      ERROR_IO_PENDING: begin //Time to wait.
        GetOverlappedResult(Device[CardNum].hDevice, pOvl^, BytesBack, true);
        Result := GetLastError;
        if Result = ERROR_NO_MORE_FILES then Result := ERROR_SUCCESS;
        //Else ERROR_OPERATION_ABORTED or other error, either way just pass it along.
      end;
      //Else some error, pass it along.
    end;
  finally
    ReleaseOverlapped(pOvl);
  end;
end;

function RelInPortStringW(CardNum, Offset, Words: LongWord; pData: PWord): LongWord; cdecl;
//var
//  BytesBack: LongWord;

begin
  Result := ERROR_NOT_SUPPORTED;
  {
  ValidateCardNum(CardNum);
  if Result <> ERROR_SUCCESS then Exit;

  Result := DoIOCTL(
    Device[CardNum].hDevice,
    IOCTL_PORT_IN_STRING,
    @BytesBack,
    0, nil,
    DataBytes, pData
  );
  }
end;

function InPortStringW(Address, Words: LongWord; pData: PWord): LongWord; cdecl;
begin
  Result := ERROR_NOT_SUPPORTED;
end;



function   RelInPortB (CardNum, Offset: LongWord                 ): Word;     cdecl;   begin Result := $AA55; if not TestValidateCardNumAndSet(CardNum) then Exit; Result := _InPortB (Device[CardNum].hDevice, Offset);        end;
function   RelInPort  (CardNum, Offset: LongWord                 ): Word;     cdecl;   begin Result := $AA55; if not TestValidateCardNumAndSet(CardNum) then Exit; Result := _InPort  (Device[CardNum].hDevice, Offset);        end;
function   RelInPortL (CardNum, Offset: LongWord                 ): LongWord; cdecl;   begin Result := $AA55; if not TestValidateCardNumAndSet(CardNum) then Exit; Result := _InPortL (Device[CardNum].hDevice, Offset);        end;
function   RelOutPortB(CardNum, Offset: LongWord; Value: Byte    ): Word;     cdecl;   begin Result := $AA55; if not TestValidateCardNumAndSet(CardNum) then Exit; Result := _OutPortB(Device[CardNum].hDevice, Offset, Value); end;
function   RelOutPort (CardNum, Offset: LongWord; Value: Word    ): Word;     cdecl;   begin Result := $AA55; if not TestValidateCardNumAndSet(CardNum) then Exit; Result := _OutPort (Device[CardNum].hDevice, Offset, Value); end;
function   RelOutPortL(CardNum, Offset: LongWord; Value: LongWord): Word;     cdecl;   begin Result := $AA55; if not TestValidateCardNumAndSet(CardNum) then Exit; Result := _OutPortL(Device[CardNum].hDevice, Offset, Value); end;

function      InPortB (Addr: LongWord                 ): Word;     cdecl;   begin if hCentralDevice = INVALID_HANDLE_VALUE then begin SetLastError(ERROR_INVALID_HANDLE); Result := $AA55; Exit; end; Result := _InPortB (hCentralDevice, Addr);        end;
function      InPort  (Addr: LongWord                 ): Word;     cdecl;   begin if hCentralDevice = INVALID_HANDLE_VALUE then begin SetLastError(ERROR_INVALID_HANDLE); Result := $AA55; Exit; end; Result := _InPort  (hCentralDevice, Addr);        end;
function      InPortL (Addr: LongWord                 ): LongWord; cdecl;   begin if hCentralDevice = INVALID_HANDLE_VALUE then begin SetLastError(ERROR_INVALID_HANDLE); Result := $AA55; Exit; end; Result := _InPortL (hCentralDevice, Addr);        end;
function      OutPortB(Addr: LongWord; Value: Byte    ): Word;     cdecl;   begin if hCentralDevice = INVALID_HANDLE_VALUE then begin SetLastError(ERROR_INVALID_HANDLE); Result := $AA55; Exit; end; Result := _OutPortB(hCentralDevice, Addr, Value); end;
function      OutPort (Addr: LongWord; Value: Word    ): Word;     cdecl;   begin if hCentralDevice = INVALID_HANDLE_VALUE then begin SetLastError(ERROR_INVALID_HANDLE); Result := $AA55; Exit; end; Result := _OutPort (hCentralDevice, Addr, Value); end;
function      OutPortL(Addr: LongWord; Value: LongWord): Word;     cdecl;   begin if hCentralDevice = INVALID_HANDLE_VALUE then begin SetLastError(ERROR_INVALID_HANDLE); Result := $AA55; Exit; end; Result := _OutPortL(hCentralDevice, Addr, Value); end;



function VBGetNumCards: LongWord; stdcall;
begin
  Result := GetNumCards;
end;

function VBQueryCardID(CardNum: LongWord; pID: PLongWord): LongWord; stdcall;
begin
  Result := QueryCardID(CardNum, pID);
end;

function VBQueryCardBase(CardNum: LongWord; pBase: PLongWord): LongWord; stdcall;
begin
  Result := QueryCardBase(CardNum, pBase);
end;

function VBWaitForIRQ(CardNum: LongWord): LongWord; stdcall;
begin
  Result := WaitForIRQ(CardNum);
end;

function VBWaitForIRQData(CardNum: LongWord; DataBytes: LongInt; pData: Pointer): LongWord; stdcall;
begin
  Result := WaitForIRQData(CardNum, DataBytes, pData);
end;

function VBRelInPortStringW(CardNum, Offset, Words: LongWord; pData: PWord): LongWord; stdcall;
begin
  Result := RelInPortStringW(CardNum, Offset, Words, pData);
end;

function VBInPortStringW(Address, Words: LongWord; pData: PWord): LongWord; stdcall;
begin
  Result := InPortStringW(Address, Words, pData);
end;



function VBRelInPortB (CardNum, Offset: LongWord                 ): Word;     stdcall; begin Result := RelInPortB (CardNum, Offset);        end;
function VBRelInPort  (CardNum, Offset: LongWord                 ): Word;     stdcall; begin Result := RelInPort  (CardNum, Offset);        end;
function VBRelInPortL (CardNum, Offset: LongWord                 ): LongWord; stdcall; begin Result := RelInPortL (CardNum, Offset);        end;
function VBRelOutPortB(CardNum, Offset: LongWord; Value: Byte    ): Word;     stdcall; begin Result := RelOutPortB(CardNum, Offset, Value); end;
function VBRelOutPort (CardNum, Offset: LongWord; Value: Word    ): Word;     stdcall; begin Result := RelOutPort (CardNum, Offset, Value); end;
function VBRelOutPortL(CardNum, Offset: LongWord; Value: LongWord): Word;     stdcall; begin Result := RelOutPortL(CardNum, Offset, Value); end;

function    VBInPortB (Addr: LongWord                 ): Word;     stdcall; begin Result := InPortB (Addr);        end;
function    VBInPort  (Addr: LongWord                 ): Word;     stdcall; begin Result := InPort  (Addr);        end;
function    VBInPortL (Addr: LongWord                 ): LongWord; stdcall; begin Result := InPortL (Addr);        end;
function    VBOutPortB(Addr: LongWord; Value: Byte    ): Word;     stdcall; begin Result := OutPortB(Addr, Value); end;
function    VBOutPort (Addr: LongWord; Value: Word    ): Word;     stdcall; begin Result := OutPort (Addr, Value); end;
function    VBOutPortL(Addr: LongWord; Value: LongWord): Word;     stdcall; begin Result := OutPortL(Addr, Value); end;





function GetDevicePaths(const ClassGUID: TGUID): TStringArray;
var
  DevInterfaceData: SP_DEVICE_INTERFACE_DATA;
  MemberIndex: Integer;
  hDevInfo: THandle;

  L: LongWord;
  pDetailData: PSP_DEVICE_INTERFACE_DETAIL_DATA;

  Buf: AnsiString;
  I, RL: Integer;

begin
  RL := 0;
  SetLength(Result, RL);

  hDevInfo := SetupDiGetClassDevs(@ClassGUID, nil, 0, DIGCF_PRESENT or DIGCF_DEVICEINTERFACE);
  if hDevInfo = 0 then Exit;

  DevInterfaceData.cbSize := sizeof(DevInterfaceData);
  MemberIndex := 0;
  while SetupDiEnumDeviceInterfaces(hDevInfo, nil, ClassGUID, MemberIndex, DevInterfaceData) do begin
    L := 0;
    SetupDiGetDeviceInterfaceDetail(hDevInfo, @DevInterfaceData, nil, 0, @L, nil);

    GetMem(pDetailData, L);
    if SizeOf(Pointer) = 8 then
      pDetailData.cbSize := 8 //The fixed portion is 4. Dunno where 8 comes from.
    else
      pDetailData.cbSize := 5 //The fixed portion is 4. Dunno where 5 comes from.
    ;

    if not SetupDiGetDeviceInterfaceDetail(hDevInfo, @DevInterfaceData, pDetailData, L, nil, nil) then begin
      FreeMem(pDetailData);
      Inc(MemberIndex);
      Continue;
    end;

    SetString(Buf, PAnsiChar(@pDetailData.DevicePath[0]), L - 4);
    FreeMem(pDetailData);
    I := Pos(AnsiChar(#0), Buf);
    if I <> 0 then SetLength(Buf, I - 1);

    SetLength(Result, RL + 1);
    Result[RL] := Buf;
    Inc(RL);
    Buf := '';

    Inc(MemberIndex);
  end;
  SetupDiDestroyDeviceInfoList(hDevInfo);
end;

procedure LoadCardList;
var
  DevicePath: TStringArray;
  ThisPath: AnsiString;
  PI, DI: Integer;
  hFile: THandle;

begin
  DevicePath := GetDevicePaths(AIO167ClassGUID);
  DI := 0;
  for PI := 0 to High(DevicePath) do begin
    ThisPath := DevicePath[PI];
    hFile := CreateFileA(PAnsiChar(ThisPath), GENERIC_WRITE or GENERIC_READ, FILE_SHARE_WRITE or FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);
    ThisPath := '';
    if hFile = INVALID_HANDLE_VALUE then Continue;

    if DI >= Length(Device) then SetLength(Device, Length(Device) + 16);
    Device[DI].hDevice := hFile;
    Device[DI].DevPath := DevicePath[PI];
    Inc(DI);
  end;
  SetLength(Device, DI);
  SetLength(DevicePath, 0);
end;

procedure InitDLL;
begin
  LoadCardList;
  hCentralDevice := CreateFile('\\.\AIO167Core', GENERIC_WRITE or GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
end;

end.
